Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_grid.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_grid.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_grid.F90	(revision 14644)
@@ -134,5 +134,5 @@
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
                   &                             1, jpi, 1, jpj,           &
-                  &                             nproc, jpnij,             &
+                  &                             narea-1, jpnij,           &
                   &                             CASTWP(glamt), CASTWP(gphit), tmask,      &
                   &                             kobsin, plam, pphi,       &
@@ -141,5 +141,5 @@
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
                   &                             1, jpi, 1, jpj,           &
-                  &                             nproc, jpnij,             &
+                  &                             narea-1, jpnij,           &
                   &                             glamu, gphiu, umask,      &
                   &                             kobsin, plam, pphi,       &
@@ -148,5 +148,5 @@
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
                   &                             1, jpi, 1, jpj,           &
-                  &                             nproc, jpnij,             &
+                  &                             narea-1, jpnij,           &
                   &                             glamv, gphiv, vmask,      &
                   &                             kobsin, plam, pphi,       &
@@ -155,5 +155,5 @@
                CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
                   &                             1, jpi, 1, jpj,           &
-                  &                             nproc, jpnij,             &
+                  &                             narea-1, jpnij,           &
                   &                             CASTWP(glamf), CASTWP(gphif), fmask,      &
                   &                             kobsin, plam, pphi,       &
@@ -180,5 +180,5 @@
       !!
       !! ** Action  : Return kproc holding the observation and kiobsi,kobsj
-      !!              valid on kproc=nproc processor only.
+      !!              valid on kproc=narea-1 processor only.
       !!   
       !! History :
@@ -252,5 +252,5 @@
          jlon     = jpiglo
          jlat     = jpjglo
-         joffset  = nproc
+         joffset  = narea-1
          jostride = jpnij
       ELSE
@@ -517,10 +517,10 @@
                         IF ( ABS( zlam - zplam(jo) ) < 1e-6 ) THEN
                            IF ( llinvalidcell(ji,jj) ) THEN
-                              kproc(jo) = nproc + 1000000
+                              kproc(jo) = narea-1 + 1000000
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
                               CYCLE
                            ELSE
-                              kproc(jo) = nproc
+                              kproc(jo) = narea-1
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
@@ -556,10 +556,10 @@
                            &          zlamtm(:,ji,jj), zphitm(:,ji,jj) ) ) THEN
                            IF ( llinvalidcell(ji,jj) ) THEN
-                              kproc(jo) = nproc + 1000000
+                              kproc(jo) = narea-1 + 1000000
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
                               CYCLE
                            ELSE
-                              kproc(jo) = nproc
+                              kproc(jo) = narea-1
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
@@ -588,10 +588,10 @@
                            &          zlamtm(:,ji,jj), zphitm(:,ji,jj) ) ) THEN
                            IF ( llinvalidcell(ji,jj) ) THEN
-                              kproc(jo) = nproc + 1000000
+                              kproc(jo) = narea-1 + 1000000
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
                               CYCLE
                            ELSE
-                              kproc(jo) = nproc
+                              kproc(jo) = narea-1
                               kobsi(jo) = ji + 1
                               kobsj(jo) = jj + 1
@@ -720,5 +720,5 @@
             ! define the following format: "(a,a,ix.x,a,ix.x,a,ix.x,a)"
             WRITE(clfmt, "('(a,a,i', i1, '.', i1',a,i', i1, '.', i1',a,i', i1, '.', i1',a)')") idg, idg, idg, idg, idg, idg
-            WRITE(cfname,      clfmt     ) TRIM(cn_gridsearchfile),'_', nproc,'of', jpni,'by', jpnj,'.nc'
+            WRITE(cfname,      clfmt     ) TRIM(cn_gridsearchfile),'_', narea-1,'of', jpni,'by', jpnj,'.nc'
          ENDIF
 
@@ -824,5 +824,5 @@
             CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,  &
                &                     1, jpi, 1, jpj,            &
-               &                     nproc, jpnij,              &
+               &                     narea-1, jpnij,            &
                &                     CASTWP(glamt), CASTWP(gphit), tmask,       &
                &                     nlons*nlats, lonsi, latsi, &
@@ -1074,5 +1074,5 @@
 
             IF ( ( .NOT. ln_grid_global ) .OR. &
-               & ( ( ln_grid_global ) .AND. ( nproc==0 ) ) ) THEN
+               & ( ( ln_grid_global ) .AND. ( narea-1==0 ) ) ) THEN
 
                CALL chkerr( nf90_create (TRIM(cfname), nf90_clobber, idfile), &
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_mpp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_mpp.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_mpp.F90	(revision 14644)
@@ -18,8 +18,7 @@
    !! obs_mpp_sum_integer   : Sum an integer from all processors
    !!----------------------------------------------------------------------
-   USE dom_oce, ONLY :   nproc, mig, mjg   ! Ocean space and time domain variables
    USE mpp_map, ONLY :   mppmap
    USE in_out_manager
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
    USE lib_mpp, ONLY :   mpi_comm_oce      ! MPP library
 #endif
@@ -61,5 +60,5 @@
       INTEGER, DIMENSION(kno), INTENT(inout) ::   kvals   ! Array to send on kroot, receive for non-kroot
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
       INTEGER :: ierr 
@@ -95,5 +94,5 @@
       INTEGER, DIMENSION(kno), INTENT(inout) ::   kvals   ! Array to send on kroot, receive for non-kroot  
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
       INTEGER :: ierr 
@@ -134,5 +133,5 @@
       INTEGER, DIMENSION(kno), INTENT(inout) ::   kobsp
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
       !
@@ -192,5 +191,5 @@
       INTEGER, DIMENSION(kno), INTENT(  out) ::   kvalsout
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
       INTEGER :: ierr
@@ -230,5 +229,5 @@
       INTEGER, INTENT(  out) ::   kvalout
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
       INTEGER :: ierr
@@ -270,5 +269,5 @@
       INTEGER :: ierr
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
 INCLUDE 'mpif.h'
@@ -318,5 +317,5 @@
       INTEGER :: ierr
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
 INCLUDE 'mpif.h'
@@ -360,5 +359,5 @@
       INTEGER :: jproc
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
 INCLUDE 'mpif.h'
@@ -412,5 +411,5 @@
       INTEGER :: jproc
       !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       !
 INCLUDE 'mpif.h'
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_prep.F90	(revision 14644)
@@ -66,5 +66,5 @@
       !! * Modules used
       USE par_oce             ! Ocean parameters
-      USE dom_oce, ONLY       :   glamt, gphit, tmask, nproc   ! Geographical information
+      USE dom_oce, ONLY       :   glamt, gphit, tmask   ! Geographical information
       !! * Arguments
       TYPE(obs_surf), INTENT(INOUT) :: surfdata    ! Full set of surface data
@@ -267,6 +267,5 @@
       USE par_oce             ! Ocean parameters
       USE dom_oce, ONLY : &   ! Geographical information
-         & gdept_1d,             &
-         & nproc
+         & gdept_1d
 
       !! * Arguments
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_prof.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_prof.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_prof.F90	(revision 14644)
@@ -404,8 +404,8 @@
                IF ( ( inpfiles(jj)%ptim(ji) >  djulini(jj) ) .AND. &
                   & ( inpfiles(jj)%ptim(ji) <= djulend(jj) )       ) THEN
-                  IF ( nproc == 0 ) THEN
-                     IF ( inpfiles(jj)%iproc(ji,1) >  nproc ) CYCLE
+                  IF ( narea == 1 ) THEN
+                     IF ( inpfiles(jj)%iproc(ji,1) >  narea-1 ) CYCLE
                   ELSE
-                     IF ( inpfiles(jj)%iproc(ji,1) /= nproc ) CYCLE
+                     IF ( inpfiles(jj)%iproc(ji,1) /= narea-1 ) CYCLE
                   ENDIF
                   llvalprof = .FALSE.
@@ -538,8 +538,8 @@
             & ( inpfiles(jj)%ptim(ji) <= djulend(jj) ) ) THEN
 
-            IF ( nproc == 0 ) THEN
-               IF ( inpfiles(jj)%iproc(ji,1) >  nproc ) CYCLE
+            IF ( narea == 1 ) THEN
+               IF ( inpfiles(jj)%iproc(ji,1) >  narea-1 ) CYCLE
             ELSE
-               IF ( inpfiles(jj)%iproc(ji,1) /= nproc ) CYCLE
+               IF ( inpfiles(jj)%iproc(ji,1) /= narea-1 ) CYCLE
             ENDIF
 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_surf.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_surf.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_read_surf.F90	(revision 14644)
@@ -300,8 +300,8 @@
                IF ( ( inpfiles(jj)%ptim(ji) >  djulini(jj) ) .AND. &
                   & ( inpfiles(jj)%ptim(ji) <= djulend(jj) )       ) THEN
-                  IF ( nproc == 0 ) THEN
-                     IF ( inpfiles(jj)%iproc(ji,1) >  nproc ) CYCLE
+                  IF ( narea == 1 ) THEN
+                     IF ( inpfiles(jj)%iproc(ji,1) >  narea-1 ) CYCLE
                   ELSE
-                     IF ( inpfiles(jj)%iproc(ji,1) /= nproc ) CYCLE
+                     IF ( inpfiles(jj)%iproc(ji,1) /= narea-1 ) CYCLE
                   ENDIF
                   llvalprof = .FALSE.
@@ -371,8 +371,8 @@
             & ( inpfiles(jj)%ptim(ji) <= djulend(jj) ) ) THEN
 
-            IF ( nproc == 0 ) THEN
-               IF ( inpfiles(jj)%iproc(ji,1) >  nproc ) CYCLE
+            IF ( narea == 1 ) THEN
+               IF ( inpfiles(jj)%iproc(ji,1) >  narea-1 ) CYCLE
             ELSE
-               IF ( inpfiles(jj)%iproc(ji,1) /= nproc ) CYCLE
+               IF ( inpfiles(jj)%iproc(ji,1) /= narea-1 ) CYCLE
             ENDIF
 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_utils.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_utils.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_utils.F90	(revision 14644)
@@ -66,6 +66,4 @@
       !! * Modules used
       USE netcdf             ! NetCDF library
-      USE dom_oce, ONLY : &  ! Ocean space and time domain variables
-         & nproc
 
       !! * Arguments
@@ -102,6 +100,4 @@
       !! * Modules used
       USE netcdf             ! NetCDF library
-      USE dom_oce, ONLY : &  ! Ocean space and time domain variables
-         & nproc
 
       !! * Arguments
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_write.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_write.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_write.F90	(revision 14644)
@@ -210,5 +210,5 @@
       idg = MAX( INT(LOG10(REAL(jpnij,wp))) + 1, 4 )            ! how many digits to we need to write? min=4, max=9
       WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg   ! '(a,a,ix.x,a)'
-      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', nproc, '.nc'
+      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', narea-1, '.nc'
 
       IF(lwp) THEN
@@ -475,5 +475,5 @@
       idg = MAX( INT(LOG10(REAL(jpnij,wp))) + 1, 4 )            ! how many digits to we need to write? min=4, max=9
       WRITE(clfmt, "('(a,a,i', i1, '.', i1, ',a)')") idg, idg   ! '(a,a,ix.x,a)'
-      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', nproc, '.nc'
+      WRITE(clfname,clfmt) TRIM(clfiletype), '_fdbk_', narea-1, '.nc'
 
       IF(lwp) THEN
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/cpl_oasis3.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/cpl_oasis3.F90	(revision 14644)
@@ -115,5 +115,5 @@
 
       !------------------------------------------------------------------
-      ! 3rd Get an MPI communicator for OPA local communication
+      ! 3rd Get an MPI communicator for OCE local communication
       !------------------------------------------------------------------
 
@@ -294,5 +294,6 @@
       !
 #if defined key_agrif
-      IF( agrif_fixed() == Agrif_Nb_Fine_Grids() ) THEN
+      ! Warning: Agrif_Nb_Fine_Grids not yet defined at this stage for Agrif_Root -> must use Agrif_Root_Only()
+      IF( Agrif_Root_Only() .OR. agrif_fixed() == Agrif_Nb_Fine_Grids() ) THEN
 #endif
       CALL oasis_enddef(nerror)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/fldread.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/fldread.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/fldread.F90	(revision 14644)
@@ -211,5 +211,5 @@
             !
             IF( sd(jf)%ln_tint ) THEN              ! temporal interpolation
-               IF(lwp .AND. kt - nit000 <= 100 ) THEN 
+               IF(lwp .AND. ( kt - nit000 <= 20 .OR. nitend - kt <= 20 ) ) THEN 
                   clfmt = "('   fld_read: var ', a, ' kt = ', i8, ' (', f9.4,' days), Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
                      &    "', records b/a: ', i6.4, '/', i6.4, ' (days ', f9.4,'/', f9.4, ')')"
@@ -223,5 +223,5 @@
                sd(jf)%fnow(:,:,:) = ztintb * sd(jf)%fdta(:,:,:,ibb) + ztinta * sd(jf)%fdta(:,:,:,iaa)
             ELSE   ! nothing to do...
-               IF(lwp .AND. kt - nit000 <= 100 ) THEN
+               IF(lwp .AND. ( kt - nit000 <= 20 .OR. nitend - kt <= 20 ) ) THEN
                   clfmt = "('   fld_read: var ', a, ' kt = ', i8,' (', f9.4,' days), Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
                      &    "', record: ', i6.4, ' (days ', f9.4, ' <-> ', f9.4, ')')"
@@ -251,5 +251,5 @@
       !!---------------------------------------------------------------------
       !
-      IF( nflag == 0 )   nflag = -( HUGE(0) - 10 )
+      IF( nflag == 0 )   nflag = -HUGE(0)
       !
       CALL fld_def( sdjf )
@@ -908,10 +908,10 @@
       TYPE(FLD)        , INTENT(inout) ::   sdjf       ! input field related variables
       !
-      INTEGER, DIMENSION(2)  :: isave
+      INTEGER  :: isave
       LOGICAL  :: llprev, llnext, llstop
       !!----------------------------------------------------------------------
       !
       llprev = sdjf%nrecsec(sdjf%nreclast) < nsec000_1jan000   ! file ends before the beginning of the job -> file may not exist
-      llnext = sdjf%nrecsec(       0     ) > nsecend_1jan000   ! file begins after the end of the job -> file may not exist 
+      llnext = sdjf%nrecsec(      1      ) > nsecend_1jan000   ! file begins after the end of the job -> file may not exist 
 
       llstop = sdjf%ln_clim .OR. .NOT. ( llprev .OR. llnext )
@@ -926,18 +926,17 @@
          IF( llprev ) THEN   ! previous file does not exist : go back to current and accept to read only the first record
             CALL ctl_warn('previous file: '//TRIM(sdjf%clname)//' not found -> go back to current year/month/week/day file')
-            isave(1:2) = sdjf%nrecsec(sdjf%nreclast-1:sdjf%nreclast)   ! save previous file info
-            CALL fld_def( sdjf )   ! go back to current file
-            sdjf%nreclast = 1   ! force to use only the first record (do as if other were not existing...)
-            sdjf%nrecsec(0:1) = isave(1:2)
+            isave = sdjf%nrecsec(sdjf%nreclast)   ! save previous file info
+            CALL fld_def( sdjf )                  ! go back to current file
+            sdjf%nreclast = 1                     ! force to use only the first record (do as if other were not existing...)
          ENDIF
          !
          IF( llnext ) THEN   ! next     file does not exist : go back to current and accept to read only the last  record 
             CALL ctl_warn('next file: '//TRIM(sdjf%clname)//' not found -> go back to current year/month/week/day file')
-            isave(1:2) = sdjf%nrecsec(0:1)    ! save next file info
-            CALL fld_def( sdjf )   ! go back to current file
-            ! -> read last record but keep record info from the first record of next file
-            sdjf%nrecsec(sdjf%nreclast-1:sdjf%nreclast) = isave(1:2)
-            sdjf%nrecsec(0:sdjf%nreclast-2) = nflag
-         ENDIF
+            isave = sdjf%nrecsec(1)               ! save next file info
+            CALL fld_def( sdjf )                  ! go back to current file
+         ENDIF
+         ! -> read "last" record but keep record info from the first record of next file
+         sdjf%nrecsec(  sdjf%nreclast  ) = isave
+         sdjf%nrecsec(0:sdjf%nreclast-1) = nflag
          !
          CALL iom_open( sdjf%clname, sdjf%num, ldiof = LEN_TRIM(sdjf%wgtname) > 0 )   
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/geo2ocean.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/geo2ocean.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/geo2ocean.F90	(revision 14644)
@@ -161,5 +161,5 @@
       ! (computation done on the north stereographic polar plane)
       !
-      DO_2D( 0, 0, 0, 1 )
+      DO_2D( 0, 1, 0, 0 )
          !                  
          zlam = plamt(ji,jj)     ! north pole direction & modulous (at t-point)
@@ -250,5 +250,5 @@
       ! =============== !
 
-      DO_2D( 0, 0, 0, 1 )
+      DO_2D( 0, 1, 0, 0 )
          IF( MOD( ABS( plamv(ji,jj) - plamv(ji,jj-1) ), 360. ) < 1.e-8 ) THEN
             gsint(ji,jj) = 0.
@@ -273,6 +273,6 @@
       ! =========================== !
       !           ! lateral boundary cond.: T-, U-, V-, F-pts, sgn
-      CALL lbc_lnk_multi( 'geo2ocean', gcost, 'T', -1.0_wp, gsint, 'T', -1.0_wp, gcosu, 'U', -1.0_wp, gsinu, 'U', -1.0_wp, & 
-                      &   gcosv, 'V', -1.0_wp, gsinv, 'V', -1.0_wp, gcosf, 'F', -1.0_wp, gsinf, 'F', -1.0_wp  )
+      CALL lbc_lnk( 'geo2ocean', gcost, 'T', -1.0_wp, gsint, 'T', -1.0_wp, gcosu, 'U', -1.0_wp, gsinu, 'U', -1.0_wp, & 
+         &                       gcosv, 'V', -1.0_wp, gsinv, 'V', -1.0_wp, gcosf, 'F', -1.0_wp, gsinf, 'F', -1.0_wp  )
       !
    END SUBROUTINE angle
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbc_oce.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbc_oce.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbc_oce.F90	(revision 14644)
@@ -87,5 +87,5 @@
    INTEGER , PUBLIC, PARAMETER ::   jp_abl     = 4        !: Atmospheric boundary layer    formulation
    INTEGER , PUBLIC, PARAMETER ::   jp_purecpl = 5        !: Pure ocean-atmosphere Coupled formulation
-   INTEGER , PUBLIC, PARAMETER ::   jp_none    = 6        !: for OPA when doing coupling via SAS module
+   INTEGER , PUBLIC, PARAMETER ::   jp_none    = 6        !: for OCE when doing coupling via SAS module
    !
    !!----------------------------------------------------------------------
@@ -94,5 +94,5 @@
    INTEGER , PUBLIC, PARAMETER ::   jp_iam_nemo = 0      !: Initial single executable configuration
    !  (no internal OASIS coupling)
-   INTEGER , PUBLIC, PARAMETER ::   jp_iam_opa  = 1      !: Multi executable configuration - OPA component
+   INTEGER , PUBLIC, PARAMETER ::   jp_iam_oce  = 1      !: Multi executable configuration - OCE component
    !  (internal OASIS coupling)
    INTEGER , PUBLIC, PARAMETER ::   jp_iam_sas  = 2      !: Multi executable configuration - SAS component
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcblk.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/SBC/sbcblk.F90	(revision 14644)
@@ -40,5 +40,5 @@
    USE sbcdcy         ! surface boundary condition: diurnal cycle
    USE sbcwave , ONLY :   cdn_wave ! wave module
-   USE lib_fortran    ! to use key_nosignedzero
+   USE lib_fortran    ! to use key_nosignedzero and glob_sum
    !
 #if defined key_si3
@@ -348,4 +348,7 @@
       !                                      !- fill the bulk structure with namelist informations
       CALL fld_fill( sf, slf_i, cn_dir, 'sbc_blk_init', 'surface boundary condition -- bulk formulae', 'namsbc_blk' )
+      sf(jp_wndi )%zsgn = -1._wp   ;   sf(jp_wndj )%zsgn = -1._wp   ! vector field at T point: overwrite default definition of zsgn
+      sf(jp_uoatm)%zsgn = -1._wp   ;   sf(jp_voatm)%zsgn = -1._wp   ! vector field at T point: overwrite default definition of zsgn
+      sf(jp_hpgi )%zsgn = -1._wp   ;   sf(jp_hpgj )%zsgn = -1._wp   ! vector field at T point: overwrite default definition of zsgn
       !
       DO jfpr= 1, jpfld
@@ -501,5 +504,6 @@
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj) ::   zssq, zcd_du, zsen, zlat, zevp
-      REAL(wp) :: ztmp
+      REAL(wp) :: ztst
+      LOGICAL  :: llerr
       !!----------------------------------------------------------------------
       !
@@ -508,31 +512,29 @@
       ! Sanity/consistence test on humidity at first time step to detect potential screw-up:
       IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*) ''
-#if defined key_agrif
-         IF(lwp) WRITE(numout,*) ' === AGRIF => Sanity/consistence test on air humidity SKIPPED! :( ==='
-#else
-         ztmp = SUM(tmask(:,:,1)) ! number of ocean points on local proc domain
-         IF( ztmp > 8._wp ) THEN ! test only on proc domains with at least 8 ocean points!
-            ztmp = SUM(sf(jp_humi)%fnow(:,:,1)*tmask(:,:,1))/ztmp ! mean humidity over ocean on proc
-            SELECT CASE( nhumi )
-            CASE( np_humi_sph ) ! specific humidity => expect: 0. <= something < 0.065 [kg/kg] (0.061 is saturation at 45degC !!!)
-               IF(  (ztmp < 0._wp) .OR. (ztmp > 0.065)  ) ztmp = -1._wp
-            CASE( np_humi_dpt ) ! dew-point temperature => expect: 110. <= something < 320. [K]
-               IF( (ztmp < 110._wp).OR.(ztmp > 320._wp) ) ztmp = -1._wp
-            CASE( np_humi_rlh ) ! relative humidity => expect: 0. <= something < 100. [%]
-               IF(  (ztmp < 0._wp) .OR.(ztmp > 100._wp) ) ztmp = -1._wp
-            END SELECT
-            IF(ztmp < 0._wp) THEN
-               IF (lwp) WRITE(numout,'("   Mean humidity value found on proc #",i6.6," is: ",f10.5)') narea, ztmp
-               CALL ctl_stop( 'STOP', 'Something is wrong with air humidity!!!', &
-                  &   ' ==> check the unit in your input files'       , &
-                  &   ' ==> check consistence of namelist choice: specific? relative? dew-point?', &
-                  &   ' ==> ln_humi_sph -> [kg/kg] | ln_humi_rlh -> [%] | ln_humi_dpt -> [K] !!!' )
-            END IF
-         END IF
-         IF(lwp) WRITE(numout,*) ' === Sanity/consistence test on air humidity sucessfuly passed! ==='
-#endif
-         IF(lwp) WRITE(numout,*) ''
-      END IF !IF( kt == nit000 )
+         ! mean humidity over ocean on proc
+         ztst = glob_sum( 'sbcblk', sf(jp_humi)%fnow(:,:,1) * e1e2t(:,:) * tmask(:,:,1) ) / glob_sum( 'sbcblk', e1e2t(:,:) * tmask(:,:,1) )
+         llerr = .FALSE.
+         SELECT CASE( nhumi )
+         CASE( np_humi_sph ) ! specific humidity => expect: 0. <= something < 0.065 [kg/kg] (0.061 is saturation at 45degC !!!)
+            IF( (ztst <   0._wp) .OR. (ztst > 0.065_wp) )   llerr = .TRUE.
+         CASE( np_humi_dpt ) ! dew-point temperature => expect: 110. <= something < 320. [K]
+            IF( (ztst < 110._wp) .OR. (ztst >  320._wp) )   llerr = .TRUE.
+         CASE( np_humi_rlh ) ! relative humidity => expect: 0. <= something < 100. [%]
+            IF( (ztst <   0._wp) .OR. (ztst >  100._wp) )   llerr = .TRUE.
+         END SELECT
+         IF(llerr) THEN
+            WRITE(ctmp1,'("   Error on mean humidity value: ",f10.5)') ztst
+            CALL ctl_stop( 'STOP', ctmp1, 'Something is wrong with air humidity!!!', &
+               &   ' ==> check the unit in your input files'       , &
+               &   ' ==> check consistence of namelist choice: specific? relative? dew-point?', &
+               &   ' ==> ln_humi_sph -> [kg/kg] | ln_humi_rlh -> [%] | ln_humi_dpt -> [K] !!!' )
+         ENDIF
+         IF(lwp) THEN
+            WRITE(numout,*) ''
+            WRITE(numout,*) ' Global mean humidity at kt = nit000: ', ztst
+            WRITE(numout,*) ' === Sanity/consistence test on air humidity sucessfuly passed! ==='
+            WRITE(numout,*) ''
+         ENDIF
+      ENDIF   !IF( kt == nit000 )
       !                                            ! compute the surface ocean fluxes using bulk formulea
       IF( MOD( kt - 1, nn_fsbc ) == 0 ) THEN
@@ -620,6 +622,6 @@
       !!---------------------------------------------------------------------
       INTEGER , INTENT(in   )                 ::   kt     ! time step index
-      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   pwndi  ! atmospheric wind at U-point              [m/s]
-      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   pwndj  ! atmospheric wind at V-point              [m/s]
+      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   pwndi  ! atmospheric wind at T-point              [m/s]
+      REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   pwndj  ! atmospheric wind at T-point              [m/s]
       REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   pqair  ! specific humidity at T-points            [kg/kg]
       REAL(wp), INTENT(in   ), DIMENSION(:,:) ::   ptair  ! potential temperature at T-points        [Kelvin]
@@ -830,7 +832,7 @@
 
          IF( ln_crt_fbk ) THEN
-            CALL lbc_lnk_multi( 'sbcblk', utau, 'U', -1._wp, vtau, 'V', -1._wp, taum, 'T', -1._wp )
+            CALL lbc_lnk( 'sbcblk', utau, 'U', -1._wp, vtau, 'V', -1._wp, taum, 'T', 1._wp )
          ELSE
-            CALL lbc_lnk_multi( 'sbcblk', utau, 'U', -1._wp, vtau, 'V', -1._wp )
+            CALL lbc_lnk( 'sbcblk', utau, 'U', -1._wp, vtau, 'V', -1._wp )
          ENDIF
 
@@ -1066,5 +1068,5 @@
             pvtaui(ji,jj) = zztmp2 * ( pvtaui(ji,jj) + pvtaui(ji  ,jj+1) )
          END_2D
-         CALL lbc_lnk_multi( 'sbcblk', putaui, 'U', -1._wp, pvtaui, 'V', -1._wp )
+         CALL lbc_lnk( 'sbcblk', putaui, 'U', -1._wp, pvtaui, 'V', -1._wp )
          !
          IF(sn_cfctl%l_prtctl)  CALL prt_ctl( tab2d_1=putaui  , clinfo1=' blk_ice: putaui : '   &
